module Types.Values
  ( String(..)
  , FilePath
  , Image(..)
  , ImageConversionSettings(..)
  , Template(..)
  ) where

import Prelude hiding (String, FilePath)
import qualified Prelude

import Data.String (IsString(..))
import Data.Text (Text)
import qualified Codec.Picture as CP

newtype String = StringWrapper { unStringWrapper :: Prelude.String }
  deriving (Eq)

instance Show String where
  show (StringWrapper s) = show s

type FilePath = String

instance IsString String where
  fromString = StringWrapper

newtype Image = ImageWrapper (CP.Image CP.PixelRGB8)
  deriving (Eq)

instance Show Image where
  show = const "Image"

data ImageConversionSettings = ResizeToWidth Int
  deriving (Eq, Show)

data Template = TemplateParts Text Text
  deriving (Eq, Show)
